import { createIframe } from "./createIframe"

export const createHiddenDom = async (docHtml: string, selector: string = 'hidden-dom', withAwaitImg = false) => (
  new Promise<HTMLDivElement>((res, rej) => {

    const onLoad = async (iframe: HTMLIFrameElement) => {
      try {
        const shadowContainer = window.document.createElement('div')

        shadowContainer.classList.add(selector)

        const parser = new DOMParser()
        const doc = parser.parseFromString(docHtml, 'text/html')

        shadowContainer.appendChild(doc.querySelector('html')!)

        iframe.contentDocument!.body.appendChild(shadowContainer)

        if (withAwaitImg) {
          const allImage = [...shadowContainer.querySelectorAll('img')]
          await Promise.all(allImage.map((img) => new Promise<void>((res, rej) => {
            img.onload = () => res()
            setTimeout(() => { rej('Картинка слишком долго грузится') }, 60000)
          })))
        }

        res(shadowContainer)
      } catch (error) {
        rej(error)
      }
    }

    createIframe('body', 'iframe-hidden-dom', onLoad)
  })
)